#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ustat.h>
#include <stdio.h>
#include <errno.h>
#include <unistd.h>


/* funcin que muestra el n del error, el mensaje asociado y finaliza la ejecucin*/
void Error(void) {

  fprintf(stderr, "ERROR %d. ", errno);
  fprintf(stderr, "%s\n", strerror(errno));
  exit(1);
}


int main(int argc, char *argv[]){
struct stat inodo;
struct ustat ubuf;
int dispositivo;



  if (argc != 2) {
    fprintf(stderr, "N de argumentos incorrecto.\n");
    exit(1);
  }

  /* comprobamos que es un dispositivo */
  if (stat(argv[1], &inodo) == -1)
    Error();

  dispositivo = inodo.st_rdev;

  if (S_ISCHR(inodo.st_mode) || S_ISBLK(inodo.st_mode)) {
    if (ustat(dispositivo, &ubuf) == -1)
      Error();

    printf("N total de bloques libres:\t%d\n", ubuf.f_tfree);
    printf("N de inodos libres:\t\t%d\n", ubuf.f_tinode);
    printf("Nombre del sistema de ficheros:\t%s\n", ubuf.f_fname);
    printf("Pack name:\t\t\t%s\n", ubuf.f_fpack);

  }
  else {
    fprintf(stderr, "ERROR, no es un dispositivo.\n");
    exit(1);
  }


}