/*******************************************************************************************************
 Oscar Martnez Valpuesta - 4 Ingeniera Superior Informtica
 C.A.S.O. Practica 3 - Aplicacin cliente servidor usando sockets de UNIX
 Descripcin: 	Se pretende realizar una version de remote shell, una aplicacin que permita ejecutar
		comandos remotamente. Para ello se crear un programa que har las funciones de servidor
		y que ser el encargado de ejecutar el comando que le enva desde una mquina remota
		otro programa cliente.
			Este es el mdulo del servidor. Los pasos a seguir son:
		* creacin del socket --> socket
		* asociacion del servicio con el socket --> bind
		* escucha del puerto por si alguien se conecta --> listen
		* aceptacion de la conexion -->	accept
		* intercambio de datos
*******************************************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <unistd.h>
#include <netinet/in.h>
#include <string.h>

#define PUERTO 5000
#define PUERTO_CSI 6571

#define LIMITE 5
#define MAXDATOS 100


/*******************************************************************************************************
Funcion que crea el socket, lo asocia al servicio y se pepara para escuchar.
Devuelve el socket o -1 si ha habido algun error.
*******************************************************************************************************/
int Servicio(void) {
struct sockaddr_in mi_addr;	/* informacin sobre mi direccin */
int sockfd;			/* socket file descriptor */

  /* creamos el socket */
  if ((sockfd = socket(AF_INET, SOCK_STREAM,0)) == -1) {
    perror("creacion socket");
    return -1;
  }

  /* asociamos el socket al servicio */
  mi_addr.sin_family = AF_INET;
/*  mi_addr.sin_port = htons(PUERTO_CSI); */
  mi_addr.sin_port = htons(PUERTO);
/*  mi_addr.sin_addr.s_addr = gethostbyname("gofio.csi.ull.es"); */
  mi_addr.sin_addr.s_addr = INADDR_ANY;
  bzero(&(mi_addr.sin_zero),8);

  if ((bind(sockfd, (struct sockaddr *)&mi_addr, sizeof(struct sockaddr))) == -1) {
    perror("bind");
    return -1;
  }

  /* nos ponemos a escuchar */
  if ((listen(sockfd, LIMITE)) == -1) {
    perror("listen");
    return -1;
  }

  return sockfd;
}

/*******************************************************************************************************/
int main(int argc, char *argv) {
int sockfd;
int n_sockfd;			/* socket despues de accept */
struct sockaddr_in su_addr;	/* informacin de la mquina que se conecta */
int tamano;
char buffer[MAXDATOS];
int fin = 0;
int pid;

  if ((sockfd = Servicio()) == -1)
    exit(1);

  /* bucle accept */
  while (1) {
    printf("esperando recibir conexin...\n");
    tamano = sizeof(struct sockaddr_in);
    if ((n_sockfd = accept(sockfd, (struct sockaddr *)&su_addr, &tamano)) == -1)
      perror("accept");
    printf("Servidor: conexin desde %s\n", inet_ntoa(su_addr.sin_addr));

    pid = fork();
    if (pid == 0) {
      /* aqui no se puede cerrar la salida estandar y duplicar prque todavia hay que leer del
         socket y daria problemas porque lo estariamos haciendo desde stdout */
      while(fin != 1) {
        fprintf(stderr,"esperando recibir datos...\n");
        read(n_sockfd, buffer, MAXDATOS);
/*        fprintf(stderr,"mensaje recibido: %s\n", buffer); */
        if (strcmp(buffer,"exit") == 0) {
          fin = 1;
          continue;
        }
        pid = fork();
        if (pid == 0) {
          close(1);			/* salida estandar */
          dup(n_sockfd);
          close(n_sockfd);
          fprintf(stderr,"ejecutando: %s\n", buffer);
          execlp(buffer,buffer,0);
          perror("execlp");
          exit(1);
        }
        else {
          if(wait(NULL) == -1)
            perror("wait");
          write(n_sockfd, "FIN", 4);
          fprintf(stderr,"FIN\n");
        }
      } /* while */
    } /* fork */
    else {
      if(wait(NULL) == -1)
        perror("wait");
      fprintf(stderr,"cerrando n_sockfd\n");
      close(n_sockfd);
    }

  } /* accept */

  return 0;}
