/*******************************************************************************************************
 Oscar Martnez Valpuesta - 4 Ingeniera Superior Informtica
 C.A.S.O. Practica 3 - Aplicacin cliente servidor usando sockets de UNIX
 Descripcin: 	Se pretende realizar una version de remote shell, una aplicacin que permita ejecutar
		comandos remotamente. Para ello se crear un programa que har las funciones de servidor
		y que ser el encargado de ejecutar el comando que le enva desde una mquina remota
		otro programa cliente.
			Este es el mdulo del cliente. Los pasos a seguir son:
		* creacin del socket --> socket
		* conexion con el servidor --> connect
		* intercambio de datos: al servidor se le enva toda la lnea de comandos, sin reparar
			si vienen argumentos o no.
*******************************************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <unistd.h>
#include <netinet/in.h>
#include <netdb.h>
#include <string.h>
#include "analizador.h"

#define PUERTO 5000
#define PUERTO_CSI 6571

#define LIMITE 5
#define MAXDATOS 100
#define MAXARG 20		/* numero maximo de argumentos */
#define PROMPT "[OscarSH]$ "

extern char *yytext;
extern int yyleng;

/*******************************************************************************************************
Funcin que realiza la conexin con el servidor pasado en el parmetro servidor
*******************************************************************************************************/
int Conecta(char *servidor) {
int sockfd;			/* socket file descriptor */
struct hostent *host;
struct sockaddr_in su_addr;	/* informacin de la mquina que a la que conectamos */
struct servent *servicio;	/* estructura de un servicio */

  /* obtenemos el puerto para un servicio caso/TCP (para que sea portable el codigo */
  servicio = (struct servent *)getservbyname("caso", "tcp");
  if (servicio == NULL) {
    perror("ERROR en getservbyname");
    return(-1);
  }

  if ((host = gethostbyname(servidor)) == NULL) {
    perror("gethostbyname");
    return -1;
  }

  /* creamos el socket */
  if ((sockfd = socket(AF_INET, SOCK_STREAM,0)) == -1) {
    perror("creacion socket");
    return -1;
  }

  /* conectamos el socket al servicio */
  su_addr.sin_family = AF_INET;
/*  su_addr.sin_port = htons(PUERTO_CSI); */
/*  su_addr.sin_port = htons(PUERTO); */
  /* puerto para el servicio caso */
  su_addr.sin_port = servicio->s_port;
  su_addr.sin_addr = *((struct in_addr *)host->h_addr);
  bzero(&(su_addr.sin_zero),8);

  if ((connect(sockfd, (struct sockaddr *)&su_addr, sizeof(struct sockaddr))) == -1) {
    perror("connect");
    return -1;
  }

  return sockfd;
}

/*******************************************************************************************************/
int main(int argc, char *argv[]) {
int sockfd;			/* socket file descriptor */
char buffer[MAXDATOS];
char c;
int fin = 0;

  if (argc != 2) {
    printf("Forma de uso: cliente hostname\n");
    exit(1);
  }

  if ((sockfd = Conecta(argv[1])) == -1)
    exit(1);

  printf("Escribe exit para terminar\n");
  while(1) {
    printf("\n%s", PROMPT);
/*    scanf("%s",buffer); */
    gets(buffer);
/*    printf("Enviando: %s\nTamao: %d\n", buffer,strlen(buffer)); */
    /* envamos los datos */
    write(sockfd, buffer,strlen(buffer)+1);
    if (strcmp(buffer,"exit") == 0)
      break;

    /* mostramos los resultados */
    fin = 0;
    while (!fin) {
      read(sockfd, &c, 1);
      if (c == 'F') {
        read(sockfd, &c, 1);
	if (c == 'I'){
          read(sockfd, &c, 1);
          if (c == 'N')
            fin = 1;
        }
      }
      if (!fin)
        printf("%c",c);
    }
  }
  close (sockfd);
  return 0;
}
