/***********************************************************************
Mdulo que realiza las llamadas de bajo nivel.
***********************************************************************/
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>
#include "estructuras.h"

/* estructura para llevar las estadisticas */
typedef struct TIPO_ESTADISTICAS {
  long int nuevos;
  long int encontrados;			/* datos encontrados en el buffer cache */
  long int liberados;
  long int retardados;			/* buffers puestos  de escritura retardada */
  long int dormidos;			/* procesos dormidos */
}ESTADISTICAS;

ESTADISTICAS est;

/* prototipos de funciones */
void Semaforo(boolean abrir);
int Da_Memoria(void);
int getblk(unsigned int disp, unsigned long int inodo, unsigned long int bloque);
int Insertar(unsigned long int *vector, unsigned long int pid);
void PutInicioFreeList(int buffer);
void PutFinFreeList(int buffer);
void OutFreeList(int buffer);
void OutHash(int buffer);
void PutHash(int buffer, unsigned long int bloque);
int bread(int fd_real, unsigned int disp, unsigned long int inodo, unsigned long int bloque);
void brelse(int buffer);
