/************************************************************************
Mdulo para la simulacin del buffer cach leyendo los datos de un fichero
y copiandolos a otro con nuestras funciones.
************************************************************************/
#include "callHi.h"
#include <sys/stat.h>	/* open */
#include <sys/types.h>
#include <fcntl.h>	/* open */
#include <unistd.h>  /* read/write */
#include <stdio.h>

#define T 17

int main(int argc, char *argv[]) {
int fd;
char datos[T];
int contador;
int i;
int fd2;	/* para la copia */
int pid;
int fd_real;

  if (argc != 2) {
    printf("Forma de uso: escribir nombre_fichero \n");
    exit(1);
  }

  pid = fork();
  if (pid == 0) {	/* hijo */

  signal(SIGUSR1, accion);
  signal(SIGUSR2, accion1);

  /* memoria para las estructuras */
  if (Da_Memoria() == -1)
    perror("No hay memoria para las estructuras.\n");

  /* inicializa la tabla de ficheros de este proceso */
  Inicializar();

  if ((fd = Abrir(argv[1], L_E)) == -1) {
    printf("ERROR, no hay espacio para ms ficheros en la tabla de ficheros.\n");
    exit (1);
  }

  for (i = 0; i< MAXFILES; i++)
    if (tabla_ficheros_real[i].fd == fd)
      fd_real = tabla_ficheros_real[i].fd_real;

  if ((fd2 = Crear("copia2", L_E)) == -1) {
    printf("ERROR, no hay espacio para ms ficheros en la tabla de ficheros.\n");
    exit (1);
  }

  contador = read(fd_real, datos, T);
  while (contador != 0) {
    Escribir(fd2,datos,contador);
    contador = read(fd_real, datos, T);
  }

  Cerrar(fd);
  Cerrar(fd2);

  /* mostramos los resultados */
  printf("\nRESULTADOS HIJO (%ld)\n", getpid());
  Mostrar();
  }

/******************************************************************************/

  else {	/* padre */
  signal(SIGUSR1, accion);
  signal(SIGUSR2, accion1);

  /* memoria para las estructuras */
  if (Da_Memoria() == -1)
    perror("No hay memoria para las estructuras.\n");

  /* inicializa la tabla de ficheros de este proceso */
  Inicializar();

  if ((fd = Abrir(argv[1], L_E)) == -1) {
    printf("ERROR, no hay espacio para ms ficheros en la tabla de ficheros.\n");
    exit (1);
  }

  for (i = 0; i< MAXFILES; i++)
    if (tabla_ficheros_real[i].fd == fd)
      fd_real = tabla_ficheros_real[i].fd_real;

  if ((fd2 = Crear("copia", L_E)) == -1) {
    printf("ERROR, no hay espacio para ms ficheros en la tabla de ficheros.\n");
    exit (1);
  }

  contador = read(fd_real, datos, T);
  while (contador != 0) {
    Escribir(fd2,datos,contador);
    contador = read(fd_real, datos, T);
  }

  Cerrar(fd);
  Cerrar(fd2);

  /* mostramos los resultados */
  printf("\nRESULTADOS PADRE (%ld)\n", getpid());
  Mostrar();
  }

  return 0;
}
