#include <fcntl.h>
#include <unistd.h>	/* read,write*/
#include <sys/time.h>
#include <sys/resource.h>

int main(int argc,char *argv[]) {
int origen;
int destino;
int tam;
int size;
struct rusage usage;
void *buffer;
  
  if (argc != 4) {
    printf("Nmero de argumentos incorrecto.\n");
    exit(1);
  }

  buffer = (void *) malloc(atoi(argv[3]));
  origen = open(argv[1], O_RDONLY);

  if (origen == -1) {
    printf("ERROR al abrir el fichero origen.\n");
    exit(1);
  }
  
  destino = creat(argv[2], 0600);
  if (destino == -1) {
    printf("ERROR al crear el archivo destino.\n");
    exit(1);
  }

  tam = atoi(argv[3]);
  size = read(origen, buffer, tam);
  while (tam == size) {
    write(destino, buffer, tam);
    size = read(origen, buffer,tam);
  }

  /* la ltima lectura no se ha escrito */
  write(destino, buffer, size);

  printf("Proceso completado.\n");
  close(origen);
  close(destino);
  if (getrusage(RUSAGE_SELF,&usage) == -1) 
    exit(1);

  printf("%d segundos, %d usegundos\n",usage.ru_utime.tv_sec,usage.ru_utime.tv_usec);
  return 0;
}
